Subject: [Cellar] namespace considerations for ebml's definition of EBML Schema

From: Dave Rice <[email-masked]>
Date: Thu, 16 Jul 2020 14:02:53 -0400

Hi cellar,
This is a late comment in regards to the EBML document, but I’m considering this dialogue.

>>>>>>> Begin forwarded message:
> 
> From: Karen Moore <[email-masked]>
> Subject: [AD - Murray] Re: AUTH48 [KC][SW]: RFC 8794 <draft-ietf-cellar-ebml-17.txt> NOW AVAILABLE
> Date: July 16, 2020 at 1:53:35 PM EDT
> To: "Murray S. Kucherawy" <[email-masked]>, Steve Lhomme <[email-masked]>, Dave Rice <[email-masked]>, Moritz Bunkus <[email-masked]>
> Cc: RFC System <[email-masked]>, Alexey Melnikov <[email-masked]>, [email-masked], [email-masked], Steven Villereal <[email-masked]>
> 
>>>>>>>> 3) In the XML Schema for EBML Schema, the URL https://ietf.org/cellar/ebml <https://ietf.org/cellar/ebml>
>>>>>>>> is provided, but it doesn't seem to be a valid site. Please confirm that this
>>>>>>>> is okay.
>>>>>>>> -->
>>>>>>> 
>>>>>>> I don't suppose we could host it on the IETF website. I'm not sure if
>>>>>>> a valid URL is necessary here, this is just a marker for a namespace.
>>>>>>> I think it only needs to be unique so that it's not mistaken with an
>>>>>>> XSD with a same name.

Within the EBML Schema example xml and the EBML Schema XSD the value of https://ietf.org/cellar/ebml <https://ietf.org/cellar/ebml> is used as an undefined and stand-in namespace. From reviewing other RFCs which define XML Schemas, I see that they don’t use this style of URL but instead use a URN guided by RFC2648.

Should we consider adding a section such as the one quoted below and changing from https://ietf.org/cellar/ebml to urn:ietf:params:xml:ns:ebml?

> ### `<EBMLSchema>` Namespace
> 
> The namespace URI for elements defined by this specification is a URN as
> defined by [@!RFC2141] that uses the namespace identifier 'ietf' defined by
> [@!RFC2648] and extended by [@!RFC3688]. This URN is:
> 
> ```
> urn:ietf:params:xml:ns:ebml
> ```

and changing from https://ietf.org/cellar/ebml to urn:ietf:params:xml:ns:ebml. This would follow the recommendation at https://tools.ietf.org/html/rfc3470#section-4.9 <https://tools.ietf.org/html/rfc3470#section-4.9>.

Dave Rice

---

From: Steve Lhomme <[email-masked]>
Date: Thu, 16 Jul 2020 23:05:07 +0200

Hi,

My understanding is that a HTTP URL with meaningful data about the
format is a plus. But it's not mandatory. It has to be distinct enough
from other namespaces existing in the world. Using a urn: would be
less useful IMO.

If we want to use a better URL that people can refer to in the future
then https://datatracker.ietf.org/doc/draft-ietf-cellar-ebml/ would be
the one to use. Or even https://tools.ietf.org/html/rfc8794 when it's
published. I don't know how permanent the URLs are, and we can never
guarantee a URL will be there in 100 years.

I don't know if the namespace we use in the XSD is normative. But even
if it is the value itself doesn't mean much.

If you want a IETF URN rather than the IETF URL for this RFC, then
"urn:ietf:rfc:8794" sounds nice. It matches the ABNF in RFC648.

I searched all (current) RFCs and there are a few "urn:ietf:rfc" in
them, like in RFC 8759:

  The namespace "urn:ietf:rfc:8759" is as defined by [RFC2648].

There's also "urn:ietf:rfc:7807" and "urn:ietf:rfc:7351".

If this normative we may add a sentence similar to RFC8759. Our text
doesn't imply it's normative:

  The following provides an XML Schema [@!XML-SCHEMA] for facilitating
verification of an EBML Schema described in (#ebml-schema).

Le jeu. 16 juil. 2020 à 20:03, Dave Rice <[email-masked]> a écrit :
> 3) In the XML Schema for EBML Schema, the URL https://ietf.org/cellar/ebml
> Within the EBML Schema example xml and the EBML Schema XSD the value of https://ietf.org/cellar/ebml is used as an undefined and stand-in namespace. From reviewing other RFCs which define XML Schemas, I see that they don’t use this style of URL but instead use a URN guided by RFC2648.
>
> and changing from https://ietf.org/cellar/ebml to urn:ietf:params:xml:ns:ebml. This would follow the recommendation at https://tools.ietf.org/html/rfc3470#section-4.9.
>
> Dave Rice
> _______________________________________________
> Cellar mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/cellar

-- 
Steve Lhomme
Matroska association Chairman

---

From: Moritz Bunkus <[email-masked]>
Date: Fri, 17 Jul 2020 10:48:29 +0200

Hey,

I agree with Reto; the URL provides more information to the user than a
urn. Personally I wouldn't want to point it to the draft website. The
https://tools.ietf.org/html/rfc8794 site, even though it doesn't exist yet,
seems to be the one providing the most useful information. So let's use
that one.

Kind regards,
mosu

---

From: Steve Lhomme <[email-masked]>
Date: Fri, 17 Jul 2020 17:00:01 +0200

OK I created this Pull Request
https://github.com/cellar-wg/ebml-specification/pull/387

---

From: Michael Richardson <[email-masked]>
Date: Fri, 17 Jul 2020 11:19:51 -0400

Best email explanation intro for those in the CC.
  https://mailarchive.ietf.org/arch/msg/cellar/cslvLodt2wbXci5VQOt9Z5MmRp0/

    > seems to be the one providing the most useful information. So let's use

The IETF is generally trying to phase out the tools.ietf.org site in favour
of the HTML that the datatracker renders for IDs, and the rfc-editor.org
site.  (this transition will take years...)

The best url will be https://www.rfc-editor.org/info/rfc8794
This points to the HTML, the XML, the PDF and the errata.

But, the origin of this conversation is to provide an XML name space for the
verification of EBML.
For that, the URN urn:ietf:rfc:8794 is probably the better choice.

--
Michael Richardson <[email-masked]>, Sandelman Software Works
 -= IPv6 IoT consulting =-

---

From: Moritz Bunkus <[email-masked]>
Date: Fri, 17 Jul 2020 17:27:55 +0200

Hey,

I defer to experience (as I don't have any in assigning namespaces). If you
think that URN urn:ietf:rfc:8794 is the way to go, that's fine with me.

Kind regards,
mosu

---

From: Steve Lhomme <[email-masked]>
Date: Fri, 17 Jul 2020 19:54:28 +0200

Same for me. I don't really care about the value. And I found 3 RFCs with such URN, so why not.
I'll submit another PR (I can't right now) and of them will be merged.
The fact the IETF is phasing out their URLs is a good incentive to use a URN which is stable.

> On 17 Jul 2020, at 17:28, Moritz Bunkus <mo=[email-masked]> wrote:
> 
> Hey,
>

---

From: Michael Richardson <[email-masked]>
Date: Fri, 17 Jul 2020 17:04:44 -0400

> think that URN urn:ietf:rfc:8794 is the way to go, that's fine with me.

I think it would be the least controversial, but I definitely do like the
idea that someone following the URL would get pointed at useful
documentation.

I'm hoping Adam will know, or will know what the best practice is here.

This is something that has to go into the ebml document, which is just
waiting for Dave Rice's okay in AUTH48, right?

---

From: Moritz Bunkus <[email-masked]>
Date: Fri, 17 Jul 2020 23:12:50 +0200

Hey,

my OK's still outstanding, too, and yes, this has to go into the document
before publication.

Kind regards,
mosu